from __b64 import b64
from __crearfuncion_calcular_udm import crearfuncion_calcular_udm
from __crearfuncion_claves import crearfuncion_claves
from __crearfuncion_firmar import crearfuncion_firmar
from __crearfuncion_verificar import crearfuncion_verificar
from __calcular_zetaCheck import calcular_zetaCheck
import __constantes as constantes


def icvar_ots (bits=256, grupo=3, t=4, split=1, consal=True, upbits=None):

	# parametros

	if upbits == None: upbits = bits

	try:
		udA = constantes.udA [(grupo, t)]
		udB = constantes.udB [(grupo, t)]
		mA = constantes.mA [(grupo, t)]
		mB = constantes.mB [(grupo, t)]
	except:
		raise ValueError ('parametros incorrectos')

	zA = len (udA) - 1
	zB = len (udB) - 1
	zCheck = calcular_zetaCheck (bits, mA, mB, split)

	# crear funciones

	calcular_udm = crearfuncion_calcular_udm (udA, udB, mA, mB)
	crearclaves = crearfuncion_claves (bits, grupo, split, zA, zB, zCheck, consal, upbits)
	firmar = crearfuncion_firmar (bits, grupo, t, split, zA, zB, zCheck, calcular_udm)
	verificar = crearfuncion_verificar (bits, grupo, t, split, calcular_udm, upbits)

	return crearclaves, firmar, verificar


# ----------------------------------------------------------------
if __name__ == '__main__':

	crearclaves, firmar, verificar = icvar_ots (bits=128, grupo=3, t=4, split=1)

	# crear claves
	priv, pub = crearclaves ()

	# firmar
	mensaje = b'abc'
	firma, sal = firmar (mensaje, priv=priv)

	# verificar
	v = verificar (mensaje, firma, sal=sal, pub=pub)

	print ('mensaje = ' + repr (mensaje))
	print ('firma = ' + b64 (firma))
	print ('sal = ' + b64 (sal))
	print ('\nverificar = ' + str (v))

